﻿Public Class Form1
    Dim orden As Byte
    Private Sub Button1_Click() Handles Button1.Click
        If ComboBox1.SelectedIndex = -1 Then Exit Sub
        'MsgBox("Conectando a : " & ComboBox1.Items(ComboBox1.SelectedIndex))
        Try
            With SerialPort1
                .PortName = ComboBox1.Items(ComboBox1.SelectedIndex)
                .BaudRate = 9600
                .Parity = IO.Ports.Parity.None
                .DataBits = 8
                .StopBits = IO.Ports.StopBits.One
                .ReadTimeout = 300 '300ms
                .WriteTimeout = 300 '300ms
            End With
            SerialPort1.Open()
            Label1.Text = "Conectado"
            Button1.Enabled = False
            Timer1.Enabled = True
        Catch ex As Exception
            Label1.Text = "Error. No Conectado "
            SerialPort1.Close()
            Button1.Enabled = True
            Timer1.Enabled = False
        End Try
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        ComboBox1.Items.Clear()
        For Each sp As String In My.Computer.Ports.SerialPortNames
            ComboBox1.Items.Add(sp)
        Next
    End Sub

    Private Sub Button7_Click(sender As System.Object, e As System.EventArgs) Handles Button7.Click
        SerialPort1.Close()
        Label1.Text = "Desconectado"
        Button1.Enabled = True
        Timer1.Enabled = False
    End Sub

    Private Sub Button8_Click(sender As System.Object, e As System.EventArgs) Handles Button8.Click
        Dim byteOut(64) As Byte
        TrackBar1.Value = 100
        TrackBar2.Value = 100
    End Sub

    Private Sub CheckBox1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If CheckBox1.Checked = True Then
            TrackBar2.Enabled = True
            TrackBar2.Value = TrackBar1.Value
            TrackBar2.Enabled = False
        Else
            TrackBar2.Enabled = True
        End If
    End Sub

    Private Sub Timer1_Tick(sender As System.Object, e As System.EventArgs) Handles Timer1.Tick
        'track bar 1
        Dim byteOut(64) As Byte, Cadena As String
        Cadena = Str(TrackBar1.Value)
        lbl_tb1.Text = TrackBar1.Value - 100
        lbl_tb2.Text = TrackBar2.Value - 100
        Dim i As Integer
        Try
            byteOut(0) = Len(Cadena) + 5 'number bytes in output message
            byteOut(1) = &H0 'should be 0 for NXT
            byteOut(2) = &H80 '&H0 = reply expected &H80 = no reply expected
            byteOut(3) = &H9 'Send Bluetooth
            byteOut(4) = &H1 'Box Number - 1
            byteOut(5) = Len(Cadena) + 1 'message size with null terminator
            For i = 1 To Len(Cadena) 'copy bytes into output array
                byteOut(i + 5) = Asc(Mid(Cadena, i, 1))
            Next
            byteOut(Len(Cadena) + 6) = &H0 'add null terminator
            SerialPort1.Write(byteOut, 0, Len(Cadena) + 7) 'send message
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
        If CheckBox1.Checked = True Then
            TrackBar2.Enabled = True
            TrackBar2.Value = TrackBar1.Value
            TrackBar2.Enabled = False
        End If

        'track bar 2
        Dim byteOut1(64) As Byte
        Cadena = Str(TrackBar2.Value)
        Try
            byteOut1(0) = Len(Cadena) + 5 'number bytes in output message
            byteOut1(1) = &H0 'should be 0 for NXT
            byteOut1(2) = &H80 '&H0 = reply expected &H80 = no reply expected
            byteOut1(3) = &H9 'Send Bluetooth
            byteOut1(4) = &H0 'Box Number - 1
            byteOut1(5) = Len(Cadena) + 1 'message size with null terminator
            For i = 1 To Len(Cadena) 'copy bytes into output array
                byteOut1(i + 5) = Asc(Mid(Cadena, i, 1))
            Next
            byteOut1(Len(Cadena) + 6) = &H0 'add null terminator
            SerialPort1.Write(byteOut1, 0, Len(Cadena) + 7) 'send message
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try

    End Sub


End Class
